module.exports = function(args, finished) {

  if (args.req.query.no) {
    let no = args.req.query.no;
    if (!no || no === '') {
      return finished({error: 'Missing or empty phone number'});
    }
    let record = this.db.use('telephone', no);
    if (!record.exists) {
      return finished({error: 'No such phone number'});
    }

    return finished({
      phone_owner: record.value
    });
  }

  if (args.req.query.name) {
    let name = args.req.query.name;
    if (!name || name === '') {
      return finished({error: 'Missing or empty name'});
    }
    var index = this.db.use('telephoneIndex', name);
    if (!index.exists) {
      return finished({error: 'No such name'});
    }

    var nos = [];
    index.forEachChild(function(no) {
      nos.push(no);
    });

    return finished({
      phone_numbers: nos
    });
  }

  finished({error: 'Invalid request'});


};


